/* matthewz text writing routines for svgalib
written 'coz vgagl never works! */

/* $Id: text.c,v 1.5 1996/07/14 12:37:35 matthew Exp $ */

#define WIDTH 8
#define HEIGHT 8

#include <vga.h>
#include <malloc.h>
#include <string.h>
#include <stdlib.h>
#include <unistd.h>
#include <stdio.h>

char font[256][WIDTH][HEIGHT];

FILE *fp;

font_init()
{
	int a,b,c;
	char d;
	fp=fopen("./kidnap.font","r");
	for (a=0;a<256;a++)
		{
			for (b=0;b<WIDTH;b++)
				{
					for (c=0;c<HEIGHT;c++)
						{
							d=fgetc(fp);
							if (d!=' ') font[a][b][c]=0;
							else font[a][b][c]=1;
							
						}
				}
		}
	fclose(fp);
}

write_char(int x, int y, int ch, int cl, int bg, char *screen, int mask)
{
	int x1, y1;
	for (y1=0;y1<HEIGHT;y1++)
		{
			for (x1=0;x1<WIDTH;x1++)
				{
					if (mask==0) {
						if (font[ch][y1][x1]==0) setpixel(x+x1,y+y1,cl,screen); 
					}
					else 
						{
							if (font[ch][y1][x1]==0) setpixel(x+x1,y+y1,cl,screen);
							else setpixel(x+x1,y+y1,bg,screen);
						}
				}
		}
}

write_string(int x, int y, char *s, int cl, int bg, char *screen, int mask)
{
	int i;
	for (i=0;i<strlen(s);i++)
		{
			write_char(x+(i*WIDTH),y,*(s+i),cl,bg,screen,mask);
		}
}
